var Data = {
	promos: null,
	projects_by_cat: [null, null, null, null, null, null],
	projects: {},
	tracks: {},
	
	serial: '',
	sendStat: function(track_id, m) {
		alert('before before sending request');
		var url = 'http://demon.videomore.ru:8081/?t='+track_id+'&s='+this.serial+'&m='+m+'&r='+API_DATA.app_id;
		var x = new XMLHttpRequest();
		x.open("GET", url, true);
		x.send(null);
		alert('after sending request');
		if (! this.first_send_stat) {
			this.first_send_stat = true;
			var instant_stat_req = new XMLHttpRequest();
			alert('sending stat');
			instant_stat_req.open("GET", 'http://videomore.ru/api/log.json?id='+this.serial+'&track_id='+track_id, true);
            instant_stat_req.send(null);
		}
	},
	
	getByUrl: function(action, params, callback) {
		params['app_id'] = API_DATA.app_id;
		params['id'] = this.serial;
		var keys = [];
		for (k in params) {
		    keys.push(k);
		}
		keys = keys.sort();
		var sig = '';
		for (var i=0; i < keys.length; i++) {
			sig += keys[i]+'='+params[keys[i]];
			if (i < keys.length-1) sig += '&';
		}
		sig += API_DATA.sig;
		params['sig'] = MD5(sig);
		
		keys.push('sig');
		var url = 'http://videomore.ru/api/'+action+'.json?';
		for (var i=0; i < keys.length; i++) {
			url += keys[i]+'='+params[keys[i]];
			if (i < keys.length-1) url += '&';
		}
		
		var x = new XMLHttpRequest();
		x.onreadystatechange = function () {
			if (x.readyState == 4) {
				if (x.status == 0 || !x.responseText) {
					alert("No connection");
					showConnectionFailure();
				}
				else {
					var data = eval( x.responseText );
					if (data.error) {
						alert(data.error.message);
					} else {
						if (callback) callback(data);
					}
				}
				x.destroy();
			}
		};
		x.open("GET", url, true);
		x.send(null);
	},
	
	getPromos: function(callback) {
		var _this = this;
		if (this.promos) {
			callback(this.promos);
		} else {
			this.getByUrl('promos', {}, function(promos) {
				_this.promos = promos;
				callback(_this.promos);
			});
		}
	},
	
	getBanners: function(callback) {
		var _this = this;
		
		function get_banners() {
			var banners = [];
			if (_this.promos.length > 0){
				var i1 = Math.floor(Math.random()*_this.promos.length);
				banners.push(_this.promos[i1]);
				if (_this.promos.length > 1){
					var i2 = i1;
					while (i2 == i1) {
						i2 = Math.floor(Math.random()*_this.promos.length);
					}
					banners.push(_this.promos[i2]);
				}
			}
			callback(banners);
		};
		
		this.getPromos(get_banners);
	},
	
	getProjects: function(category, callback) {
		var _this = this;
		if (this.projects_by_cat[category]) {
			callback(this.projects_by_cat[category]);
		} else {
			this.getByUrl('projects', {category_id: category}, function(projects) {
				_this.projects_by_cat[category] = projects;
				for (var i in projects) {
					_this.projects[projects[i].id] = projects[i];
				}
				callback(projects);
			});
		}
	},
	
	getProject: function(id, callback) {
		var _this = this;
		if (this.projects[id]) {
			callback(this.projects[id]);
		} else {
			this.getByUrl('projects', {project_id: id}, function(projects) {
				for (var i in projects) {
					_this.projects[projects[i].id] = projects[i];
				}
				callback(_this.projects[id]);
			});
		}
	},

	setProjectFavorited: function(project_id, val, callback) {
		this.projects[project_id].favorited = val;
		this.getByUrl('favorite', {project_id: project_id}, callback);
	},
	
    getFavoriteProjects: function(callback) {
                  var _this = this;
                  _this.getByUrl('favorite_projects', {}, function(projects) {
                    var ids = [];
                    for (i in projects) {
                      ids.push(projects[i].id);
                    }
                    alert(ids);
                    _this.getByUrl('session_projects', {'project_id': ids.join(',')}, function(session_projects) {
                      var projects_hash = {};
                      for (var i in session_projects) {
                        var x = session_projects[i];
                        projects_hash[x.project_id] = x;
                      }
                      for (var i in projects) {
                        if (projects_hash[projects[i].id]) {
                          projects[i].favorited = projects_hash[projects[i].id].favorited;
                          projects[i].last_track = projects_hash[projects[i].id].last_track;
                          projects[i].seen_count = projects_hash[projects[i].id].seen_count;
                        }
                        _this.projects[projects[i].id] = projects[i];
                      }
                      callback(projects);
                    });
                  });
    },

    getRecentProjects: function(callback) {
                  var _this = this;
                  _this.getByUrl('recent_projects', {}, function(projects) {
                    var ids = [];
                    for (i in projects) {
                      ids.push(projects[i].id);
                    }
                    alert(ids);
                    _this.getByUrl('session_projects', {'project_id': ids.join(',')}, function(session_projects) {
                      var projects_hash = {};
                      for (var i in session_projects) {
                        var x = session_projects[i];
                        projects_hash[x.project_id] = x;
                      }
                      for (var i in projects) {
                        if (projects_hash[projects[i].id]) {
                          projects[i].favorited = projects_hash[projects[i].id].favorited;
                          projects[i].last_track = projects_hash[projects[i].id].last_track;
                          projects[i].seen_count = projects_hash[projects[i].id].seen_count;
                        }
                        _this.projects[projects[i].id] = projects[i];
                      }
                      callback(projects);
                    });
                  });
    },

	getTracks: function(project_id, start, sort, callback) {
		var _this = this;
		var per_page = 10;
		this.getProject(project_id, function(project) {
			if (start >= project.overall_count) {
				callback([]);
				return;
			}
			if (!_this.tracks[project_id]) _this.tracks[project_id] = {};
			if (!_this.tracks[project_id][sort]) _this.tracks[project_id][sort] = [];

			var r = _this.tracks[project_id][sort].slice(start, start+6);
			if (r.length > 4 || start+r.length == project.overall_count) {
				callback(r);
			} else {
				var page = Math.ceil(_this.tracks[project_id][sort].length/per_page);
				_this.getByUrl('tracks', {project_id: project_id, per_page: per_page, page: page+1, order: sort ? 'episode desc, published_at desc' : 'episode asc, published_at asc'}, function(tracks) {
					_this.tracks[project_id][sort].splice(page*per_page);
					_this.tracks[project_id][sort] = _this.tracks[project_id][sort].concat(tracks);
					r = _this.tracks[project_id][sort].slice(start, start+6);
					callback(r);
				});
			}
		});
	},

	getTrackIndex: function(project_id, track_id, sort, callback) {
		var _this = this;
		if (!track_id) return callback(0, null);
		this.getProject(project_id, function(project) {
			_this._findNext(project, 0, sort, track_id, callback);
		});
	},
	_findNext: function(project, start, sort, track_id, callback) {
		var _this = this;
		this.getTracks(project.id, start, sort, function() {
			var len = _this.tracks[project.id][sort].length;
			var r = null;
			var track = null;
			for (var i = start; i < len; i++) {
				if (_this.tracks[project.id][sort][i].id == track_id) {
					r = i;
					track = _this.tracks[project.id][sort][i];
					break;
				}
			}
			if (r || len == project.overall_count) {
				callback(r, track);
			} else {
				_this._findNext(project, len, sort, track_id, callback);
			}
		});
	},

	search: function(val, callback) {
		this.getByUrl('suggestions', {q: val}, function(data) {
			//callback([{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"},{project_id: 22951, title: "Дневник доктора Зайцевой Дневник доктора Зайцевой"}]);
			callback(data.map(function(el) { return {title: el[1], project_id: el[0]}; }));
		});
	}
};
