var PageProject = function() {
	//dom элементы
	this.el_content = document.getElementById('page_project');
	this.el_tabinfo = document.getElementById('page_project_tabinfo');
	this.el_track_tab = document.getElementById('page_project_track_tab');
	this.el_track_img = document.getElementById('page_project_track_img');
	this.el_track_progress = document.getElementById('page_project_track_progres');
	this.el_track_player = document.getElementById('page_project_track_player');
	this.el_track_btn_play = document.getElementById('page_project_btn_play');
	this.el_track_btn_stop = document.getElementById('page_project_btn_stop');
	this.el_track_btn_prog = document.getElementById('page_project_btn_prog');
	this.el_track_title = document.getElementById('page_project_track_title');
	this.el_track_director = document.getElementById('page_project_track_director');
	this.el_track_genre = document.getElementById('page_project_track_genre');
	this.el_track_year = document.getElementById('page_project_track_year');
	this.el_track_episodes = document.getElementById('page_project_track_episodes');
	this.el_track_stars = document.getElementById('page_project_track_stars');
	this.el_track_desc = document.getElementById('page_project_track_desc');
    this.el_track_items = document.getElementById('page_project_track_items');
	this.el_btn_up = document.getElementById('page_project_btn_up');
	this.el_btn_down = document.getElementById('page_project_btn_down');
	this.el_scroll = document.getElementById('page_project_scroll');
	this.el_player = document.getElementById('player_obj');
	
	this.project = null;
	this.tracks_index = 0;
	this.tracks = [];
	this.curr_track = null;
	this.sort = 0;
	this.loading = false;
};

PageProject.prototype.show = function(project_id) {
	show(this.el_content);
	document.getElementById('content').style.backgroundImage = "url('resource/images/bg_for_project.png')";
	alert(document.getElementById('content').style.backgroundImage);
	alert(document.getElementById('content'));
	hide(this.el_track_tab);
	this.el_track_img.src = URL_PREFIX+'images/no.gif';
	hide(this.el_track_player);
	this.el_track_progress.style.backgroundPositionX = '-'+SIZES.player.progress_width+'px';
	widgetAPI.putInnerHTML(this.el_track_progress, '');
	widgetAPI.putInnerHTML(this.el_track_title, '');
	widgetAPI.putInnerHTML(this.el_track_director, '');
	widgetAPI.putInnerHTML(this.el_track_genre, '');
	widgetAPI.putInnerHTML(this.el_track_year, '');
	widgetAPI.putInnerHTML(this.el_track_episodes, '');
	widgetAPI.putInnerHTML(this.el_track_stars, '');
   	widgetAPI.putInnerHTML(this.el_track_desc, '');
    widgetAPI.putInnerHTML(this.el_track_items, '<div class="pre-min act"><img src="'+URL_PREFIX+'images/pre_mini.gif" width="80" height="28"></div>');

	animateInitY(this.el_track_items, 0, 0.5);
	animateInitY(this.el_scroll, 0, 0.5);

	this.project = this.curr_track = null;
	this.tracks = [];
	this.setBtns();
	this.tracks_index = 0;
	
	var _this = this;
	Data.getProject(project_id, function(project) {
		_this.project = project;
		Data.getTrackIndex(project_id, project.last_track, _this.sort, function(index, track) {
			if (index) {
				_this.tracks_index = index;
				if (_this.tracks_index + 5 > project.overall_count) _this.tracks_index = project.overall_count-4;
				if (_this.tracks_index < 0) _this.tracks_index = 0;
				_this.curr_track = track;
			}
			_this.showTrack();
			_this.showTracks(true);
            window.onKeyPlay = function() {
			  if (player.buffering) return;
			  if (player.state == 2) {
				player.resume();
              } else {
				if (buttons.hover_btn.k > 18 && buttons.hover_btn.k < 25) {
					var delta = buttons.hover_btn.k - 19;
					var track = _this.tracks[delta];
					if ((_this.curr_track != track) || (player.state == 0)) {
						_this.curr_track = track;
						_this.showTrack(true);
						_this.showTrack(true, true);
					}
				}
			  }
				/*
				if (player.state != 1 && player.track)
					if (player.state == 2) {
						player.resume();
                    } else {
                        player.play();
                }*/
            };
            window.onKeyPause = function() {
				if (player.buffering) return;
			//	if (player.state == 1)
					player.pause();
            };
            window.onKeyStop = function() {
                if (player.state != 0) {
					player.stop();
					if (player.fullscreen) player.setWindow();
				}
            };
			window.onKeyFForward = function() {
				if (player.state == 1)
					player.seek(30);
			}
			window.onKeyRewind = function() {
				if (player.state == 1)
					player.seek(-30);
			}
		});
	});
        // обработка колеса для magic пульта
        this.el_track_items.onmousewheel = function(e) {
            //console.log(e.wheelDelta);
            if (e.wheelDelta > 0) { // up
                 _this.el_btn_up.onclick();
            }
            else { // down
                _this.el_btn_down.onclick();
            }
        };
};

PageProject.prototype.hoverTrack = function(btn) {
	/*var delta = btn.k - 19;
	var track = this.tracks[delta];
	if (this.curr_track != track) {
		this.curr_track = track;
		this.showTrack(true);
	}*/
};

PageProject.prototype.clickTrack = function(btn) {
	if (player.buffering) return;
	var delta = btn.k - 19;
	var track = this.tracks[delta];
	if ((this.curr_track != track) || (player.state == 0)) {
		this.curr_track = track;
		this.showTrack(true);
		this.showTrack(true, true);
	} else {
		if (player.state == 1) player.setFullscreen();
	}
};

PageProject.prototype.setBtns = function() {
	var _this = this;
	function fn_btn_click(delta) {
		if (animated) return;
		if (_this.tracks_index == 0 && delta == -1) return;
		if (_this.tracks_index+4 >= _this.project.overall_count && delta == 1) return;
		if (_this.loading && delta == 1) return;

		_this.tracks_index += delta;
		animateY(_this.el_track_items, -Math.floor(_this.tracks_index*SIZES.track.height), function() {
			_this.showTracks();
		});
		var y = Math.round(_this.tracks_index * SIZES.track.scroll_height / (_this.project.overall_count-4));
		if (y < 0) y = 0;
		animateY(_this.el_scroll, y);
	};

	//плеер
	buttons.clear(10);
	buttons.set(10, this.el_track_btn_play, [1,11,null,null, true]);
	buttons.set(11, this.el_track_btn_stop, [1,20,null,10, true]);
	//buttons.set(12, this.el_track_btn_prog, [1,20,null,11, true]);
	this.el_track_img.onclick = function() {
		if (_this.curr_track) _this.showTrack(true, true);
	}
	
	//кнопки внизу
	onKeyBack = showCurrPage;
	onKeyGreen = function() {
		if (player.fullscreen) {
			player.setWindow();
		} else if (player.state > 0) {
			player.setFullscreen();
		}
	};

	onKeyRed = function() {
		if (player.fullscreen) return;
		if (!_this.project) return;
		removeClass(_this.el_tabinfo.children[0], ['on', 'off']);
		if (_this.project.favorited) {
			addClass(_this.el_tabinfo.children[0], 'off');
			Data.setProjectFavorited(_this.project.id, false);
			if (!_this.curr_track) hide(_this.el_track_tab);
		} else {
			addClass(_this.el_tabinfo.children[0], 'on');
			Data.setProjectFavorited(_this.project.id, true);
			if (!_this.curr_track) show(_this.el_track_tab);
		}
		show(_this.el_tabinfo);
		setTimeout(function() {
			hide(_this.el_tabinfo);
		}, 3000);
	};
	onKeyYellow = function() {
		if (player.fullscreen) return;
		if (_this.sort) {
			_this.sort = 0;
		} else {
			_this.sort = 1;
		}
		animateInitY(_this.el_track_items, 0, 0.5);
		animateInitY(_this.el_scroll, 0, 0.5);
		_this.tracks_index = 0;
		_this.after_scrolling_up = true;
		_this.showTracks();
	};
	//выключаем кнопку фулскрина
	//buttons.disable(14);
	//скролл
	buttons.set(17, this.el_btn_up, [7,null,18,null, true], function() { fn_btn_click(-1); });
	buttons.set(18, this.el_btn_down, [17,null,null,null, true], function() { fn_btn_click(1); });
};

PageProject.prototype.showTrack = function(show_track, show_player) {
	var _this = this;
	if (show_track) {
		if (show_player) {
			if (player.state == 1 && player.track.id == this.curr_track.id) return;
			player.init(this.curr_track, function() { _this.nextTrack(); });
			show(this.el_player);
            show(this.el_track_player);
            
            buttons[1].down = buttons[2].down = 10;
			for(var i = 19; i <= 24; i++) {
				if (buttons[i]) buttons[i].left = 11;
			}
            
			this.project.last_track = this.curr_track.id;
            player.play();
		} else {
			hide(this.el_player);
            hide(this.el_track_player);
			hide(this.el_track_tab);
			hide(this.el_track_progress);
			show(this.el_track_img);
			this.el_track_img.src = this.curr_track.normal_thumbnail_url;
			this.el_track_stars.style.width = Math.round(this.curr_track.rating*SIZES.player.stars_width/5)+'px';
			widgetAPI.putInnerHTML(this.el_track_desc, this.curr_track.title+'<br>'+clipText(this.curr_track.description || this.project.description, 320));
			
			buttons[1].down = buttons[2].down = 19;
			for(var i = 19; i <= 24; i++) {
				if (buttons[i]) buttons[i].left = null;
			}
			
			player.stop();
		}
	} else {
		hide(this.el_player);
		hide(this.el_track_player);
		if (this.project.favorited) show(this.el_track_tab);
		else hide(this.el_track_tab);
		show(this.el_track_img);
		this.el_track_img.src = this.project.big_thumbnail;
		show(this.el_track_progress);
		widgetAPI.putInnerHTML(this.el_track_progress, '<center><span class="value"' + (this.project.seen_count / this.project.overall_count * 100 < 50 ? ' style="color: white"' : '') +'>'+this.project.seen_count+'/'+this.project.overall_count+'</span></center>');
		this.el_track_progress.style.backgroundPositionX = (Math.round(this.project.seen_count*SIZES.player.progress_width / this.project.overall_count)-SIZES.player.progress_width)+'px';
		widgetAPI.putInnerHTML(this.el_track_title, this.project.title);
		widgetAPI.putInnerHTML(this.el_track_director, this.project.director);
		widgetAPI.putInnerHTML(this.el_track_genre, this.project.genre);
		widgetAPI.putInnerHTML(this.el_track_year, this.project.year);
		widgetAPI.putInnerHTML(this.el_track_episodes, this.project.overall_count);
		this.el_track_stars.style.width = Math.round(this.project.rating/5*SIZES.player.stars_width)+'px';
		widgetAPI.putInnerHTML(this.el_track_desc, clipText(this.project.description, 320));
	}
};

PageProject.prototype.nextTrack = function() {
	var delta = this.sort ? -1 : 1;
	var k;
	alert("nextTrack: delta=" + delta);
	for (var i=0; i < this.tracks.length; i++) {
		if (this.tracks[i] == this.curr_track) k = i + delta;
	}
	alert("nextTrack: k=" + k + ", this.tracks.length=" + this.tracks.length);
	if ((k < 0 || k >= this.tracks.length) && player.fullscreen) {
		player.setWindow();
		return;
	}
	animated = false;

	alert("tracks =>");
	for (var i=0;i<this.tracks.length;i++)
		alert("    * " + this.tracks[i].title);
	alert("nextTrack: old_track=" + this.curr_track.title);
	this.curr_track = this.tracks[k];
	alert("nextTrack: new_track=" + this.curr_track.title);
	this.el_track_img.src = this.curr_track.normal_thumbnail_url;
	this.el_track_stars.style.width = Math.round(this.curr_track.rating*SIZES.player.stars_width/5)+'px';
	widgetAPI.putInnerHTML(this.el_track_desc, this.curr_track.title+'<br>'+clipText(this.curr_track.description || this.project.description, 320));

	player.track = this.curr_track;
	player.curr_minute = null;
	this.project.last_track = this.curr_track.id;

    if (buttons.hover_btn && buttons.hover_btn.k >= 19 && buttons.hover_btn.k < 24) this.next_focus_btn = buttons.hover_btn.k == 19 ? 20 : buttons.hover_btn.k;
	buttons.hover_btn = null;
	alert("nextTrack: next_focus_btn=" + this.next_focus_btn);
	if (this.sort) buttons[17].el.onclick();
	else buttons[18].el.onclick();

	alert("nextTrack: setting player size and position. player.fullscreen=" + player.fullscreen);
	if (player.fullscreen) {
		player.el_player.SetDisplayArea(0, 0, 960, 540);
		buttons[30].el.onmouseover();
	}
	else {
		player.el_player.SetDisplayArea(36, 92, 291, 164);
	}
	alert("nextTrack: starting player");
	player.play();
};

PageProject.prototype.showTracks = function(first) {
	this.loading = true;
	var _this = this;
	var start_index = this.tracks_index > 0 ? this.tracks_index - 1 : 0;
	Data.getTracks(this.project.id, start_index , this.sort, function(tracks) {
		_this.tracks = tracks;
		if (document.getElementById('content').className.indexOf('page-project') < 0) return;
		_this.renderTracks();
		if (document.getElementById('content').className.indexOf('page-project') < 0) return;
		
		var els = [];
		for (var i=0; i < _this.tracks.length; i++) {
			els.push('page_project_track_'+i);
		}
		buttons.setGroup(19, els, '6x1', true, function(btn) {_this.clickTrack(btn); }, function(btn) {_this.hoverTrack(btn); });
                if (player.state == 1) //TOFIX
                    for (var i = 19;i<25;i++)
                        if (buttons[i]) buttons[i].left = 11;

		
		if (first) {
			animateInitY(_this.el_track_items, -Math.floor(_this.tracks_index*SIZES.track.height), 0.5);
			var y = Math.round(_this.tracks_index * SIZES.track.scroll_height / (_this.project.overall_count-4));
			if (y < 0) y = 0;
			animateInitY(_this.el_scroll, y, 0.5);
		}

		if (tracks.length > 0) {
			var first_btn = _this.tracks_index > 0 ? 20 : 19;
			buttons[1].down = buttons[2].down = buttons[3].down = buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = first_btn;
			buttons[first_btn].up = 4;
			buttons[17].left = first_btn;

			var last = 18+tracks.length;
			if (last > 23) last = 23;
			if (_this.tracks_index == 0 && last > 22) last = 22;

			buttons[18].left = last;
			
			if (first) {
				if (_this.curr_track) {
					_this.showTrack(true);
					_this.showTrack(true, true);
				}
				if (_this.tracks_index > 0) {
					buttons[20].el.onmouseover();
				} else {
					buttons[19].el.onmouseover();
				}
			}
		}
		
		if (tracks.length < 5) {
			hide(_this.el_btn_up);
			hide(_this.el_btn_down);
			hide(_this.el_scroll.parentElement);
		} else {
			show(_this.el_btn_up);
			show(_this.el_btn_down);
			show(_this.el_scroll.parentElement);
		}
		
		if (buttons[19] && tracks.length > 4) buttons[19].right = 17;
		if (buttons[20] && tracks.length > 4) buttons[20].right = 17;
		if (buttons[21] && tracks.length > 4) {
			if (_this.tracks_index == 0) {
				buttons[21].right = 18;
			} else {
				buttons[21].right = 17;
			}
		}
		if (buttons[22] && tracks.length > 4) buttons[22].right = 18;
		if (buttons[23] && tracks.length > 4) buttons[23].right = 18;
		if (buttons[24] && tracks.length > 4) buttons[24].right = 18;
		// для скролла вверх с помощью VK_UP вешаем обработчик на hover на верхней кнопке
		if (_this.tracks_index > 0) {
			// используем невидимую кнопку v_up
			buttons.set(19, 'v_up', [null, null, null, null, true], null, function() {
			// используем невидимую кнопку v_up
				_this.after_scrolling_up = true;
				_this.el_btn_up.onclick();
			});
			buttons[20].up = 19;
		}
		// для скролла вниз с помощью VK_DOWN вешаем обработчик на hover на нижней кнопке
		if (_this.tracks_index + 4 < _this.project.overall_count) {
		  // используем невидимую кнопку v_down. мы могли использовать page_project_track_5,
		  // но её не существует, если мы находимся на 10 элементе,
		  // так как загрузка происходит порциями по 10 роликов
			buttons.set(last+1, 'v_down', [null, null, null, null, true], null, function() {
				_this.after_scrolling_down = true;
				_this.el_btn_down.onclick();
			});
			buttons[last].down = last+1;
		}
		if (_this.after_scrolling_up) {
			buttons[first_btn].el.onmouseover();
			_this.after_scrolling_up = false;
		}
		if (_this.after_scrolling_down) {
			buttons[last].el.onmouseover();
			_this.after_scrolling_down = false;
		}
		if (_this.next_focus_btn) {
			buttons[_this.next_focus_btn].el.onmouseover();
			_this.next_focus_btn = null;
		}
		_this.loading = false;
	});
};

PageProject.prototype.renderTracks = function() {
	var html = '';
	var els = [];
	var start_index = this.tracks_index > 0 ? this.tracks_index - 1 : 0;
	alert("renderTracks: margin-top=" + start_index*SIZES.track.height);
	for (var i=0; i < this.tracks.length; i++) {
		html += '<div class="project-seri-item" id="page_project_track_'+i+'"'+((i == 0) ? ' style="margin-top: '+start_index*SIZES.track.height+'px"' : '')+
			'><div class="ps-item-img"><div class="ps-item-img-bord"></div>'+(this.tracks[i].recent ? '<div class="new-ser"></div>' : '')+'<img src="'+this.tracks[i].small_thumbnail_url+'" width="'+SIZES.track.img_width+'" height="'+SIZES.track.img_height+'"></div>'+
			'<table class="ps-itemt" cellspacing="0" cellpadding="0"><tr><td class="ser" colspan="2"><div>'+this.tracks[i].title+' '+
			'</div></td></tr>'+
			'<tr><td><div class="ministars" style="width:'+Math.round(this.tracks[i].rating/5*SIZES.track.stars_width)+'px;"></div></td><td class="time">'+formatTime(this.tracks[i].duration)+'</td></tr>'+
			'</table><div class="clear"></div></div>';
	}
	if (start_index + this.tracks.length < this.project.overall_count && this.tracks.length < 6) {
		html += '<div class="pre-min act"><img src="'+URL_PREFIX+'images/pre_mini.gif" width="80" height="28"></div>';
	}
	this.el_track_items.style.width = SIZES.track.height*(this.tracks.length+1)+'px';
	widgetAPI.putInnerHTML(this.el_track_items, html);
};

PageProject.prototype.hide = function() {
	onKeyBack = onKeyGreen = onKeyRed = onKeyYellow = onKeyPlay = onKeyPause = onKeyStop = null;
	player.buffering = false; player.stop();
	hide(this.el_player);
	hide(this.el_content);
	document.getElementById('content').style.backgroundImage = "url('resource/images/bg.jpg')";
};
